//+------------------------------------------------------------------+
//|                                                      Diamond.mq4 |
//|         Copyright (c) 2014, B.O.R. - Bullet Proof Binary Signals |
//+------------------------------------------------------------------+


#property copyright "B.O.R. - Bullet Proof Binary Signals"
#property link "http://www.world-record.ch/donate"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 White
#property indicator_color2 White
#property indicator_width1 2
#property indicator_width2 2

extern int      Depth     = 42;
extern int      Deviation =  5;
extern int      Backstep  =  3;

double DiamondUpBuffer[];
double DiamondDnBuffer[];

//+------------------------------------------------------------------+

int init() {
   IndicatorBuffers(2);
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 217);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 218);
   SetIndexBuffer(0, DiamondUpBuffer);
   SetIndexBuffer(1, DiamondDnBuffer);
   SetIndexEmptyValue(0, 0.0);
   IndicatorShortName("Diamond");
   return (0);
}

//+------------------------------------------------------------------+

int start() {
   double val;
   double res;
   double currenthigh;
   double currentlow;
   double lasthigh;
   double lastlow;
   
   for (int i = Bars - Depth; i >= 0; i--) {
      val = Low[iLowest(NULL, 0, MODE_LOW, Depth, i)];
      if (val == lastlow) val = 0.0;
      else {
         lastlow = val;
         if (Low[i] - val > Deviation * Point) val = 0.0;
         else {
            for (int k = 1; k <= Backstep; k++) {
               res = DiamondUpBuffer[i + k];
               if (res != 0.0 && res > val) DiamondUpBuffer[i + k] = 0.0;
            }
         }
      }
      DiamondUpBuffer[i] = val;
      
      val = High[iHighest(NULL, 0, MODE_HIGH, Depth, i)];
      if (val == lasthigh) val = 0.0;
      else {
         lasthigh = val;
         if (val - High[i] > Deviation * Point) val = 0.0;
         else {
            for (k = 1; k <= Backstep; k++) {
               res = DiamondDnBuffer[i + k];
               if (res != 0.0 && res < val) DiamondDnBuffer[i + k] = 0.0;
            }
         }
      }
      DiamondDnBuffer[i] = val;
   }
   
   lasthigh = -1;
   int lasthighpos = -1;
   lastlow = -1;
   int lastlowpos = -1;
   
   for (i = Bars - Depth; i >= 0; i--) {
      currenthigh = DiamondUpBuffer[i];
      currentlow = DiamondDnBuffer[i];
      if (currenthigh == 0.0 && currentlow == 0.0) continue;
      if (currentlow != 0.0) {
         if (lasthigh > 0.0) {
            if (lasthigh < currentlow) DiamondDnBuffer[lasthighpos] = 0;
            else DiamondDnBuffer[i] = 0;
         }
         if (lasthigh < currentlow || lasthigh < 0.0) {
            lasthigh = currentlow;
            lasthighpos = i;
         }
         lastlow = -1;
      }
      if (currenthigh != 0.0) {
         if (lastlow > 0.0) {
            if (lastlow > currenthigh) DiamondUpBuffer[lastlowpos] = 0;
            else DiamondUpBuffer[i] = 0;
         }
         if (currenthigh < lastlow || lastlow < 0.0) {
            lastlow = currenthigh;
            lastlowpos = i;
         }
         lasthigh = -1;
      }
   }
   
   for (i = Bars - 1; i >= 0; i--) {
      if (i >= Bars - Depth) DiamondUpBuffer[i] = 0.0;
      else {
         res = DiamondDnBuffer[i];
         if (res != 0.0) DiamondDnBuffer[i] = res;
      }
   }
   return (0);
}

//+------------------------------------------------------------------+